#property indicator_chart_window
#property indicator_buffers 4
#property indicator_color1  LimeGreen
#property indicator_color2  Gold
#property indicator_color3  Aqua
#property indicator_color4  Magenta

extern string TimeFrame        = "current time frame";
extern int    maPeriod1        = 14;
extern int    Ma1Type          = MODE_SMA;
extern int    maPeriod2        =  5;
extern int    Ma2Type          = MODE_SMA;
extern int    MaPrice          = PRICE_CLOSE;
extern int    arrowSize        = 2;
extern bool   ArrowsOnFirstBar = true;

double ma1[];
double ma2[];
double CrossUp[];
double CrossDn[];
double trend[];
string indicatorFileName;
bool   returnBars;
int    timeFrame;

//
//
//
//
//

int init()
{
   IndicatorBuffers(5);
   SetIndexBuffer(0,ma1);
   SetIndexBuffer(1,ma2);
   SetIndexBuffer(2,CrossUp);  SetIndexStyle(2,DRAW_ARROW,0,arrowSize); SetIndexArrow(2,233);
   SetIndexBuffer(3,CrossDn ); SetIndexStyle(3,DRAW_ARROW,0,arrowSize); SetIndexArrow(3,234);
   SetIndexBuffer(4,trend);
      timeFrame         = stringToTimeFrame(TimeFrame); // check the time frame
      indicatorFileName = WindowExpertName();           // save the indicator name for iCustom call
      returnBars        = TimeFrame == "returnBars";    // check if number of changed bars is asked for
   return(0); 
}
int deinit() { return(0); }

//
//
//
//
//

int start() 
{
   int counted_bars = IndicatorCounted();
      if(counted_bars < 0) return(-1);
      if(counted_bars > 0) counted_bars--;
         int limit = MathMin(Bars-counted_bars,Bars-1);
         
         //
         //
         //    if the number of changed bars in the target time frame is required
         //    then store that number in the first buffer and in current bar value
         //    that way it can be retrieved buy the indicator using iCistom() call
         //
         //
         
         if (returnBars) { ma1[0] = limit+1; return(0); }
         if (timeFrame!=Period())
         {
            int shift = -1; if (ArrowsOnFirstBar) shift=1;
            limit = MathMax(limit,MathMin(Bars-1,iCustom(NULL,timeFrame,indicatorFileName,"returnBars",0,0)*timeFrame/Period())); // check How many bars in the target time frame have changed
            for (int i=limit; i>=0; i--)
            {
               int y = iBarShift(NULL,timeFrame,Time[i]); 
               int x = iBarShift(NULL,timeFrame,Time[i+shift]);              
                  ma1[i]     = iCustom(NULL,timeFrame,indicatorFileName,"",maPeriod1,Ma1Type,maPeriod2,Ma1Type,MaPrice,arrowSize,0,y);  // call the indicator itself in the target time frame
                  ma2[i]     = iCustom(NULL,timeFrame,indicatorFileName,"",maPeriod1,Ma1Type,maPeriod2,Ma1Type,MaPrice,arrowSize,1,y);  // to get the results of regular calculation
            if (x!=y)
            {
                  CrossUp[i] = iCustom(NULL,timeFrame,indicatorFileName,"",maPeriod1,Ma1Type,maPeriod2,Ma1Type,MaPrice,arrowSize,2,y);  // call the indicator itself in the target time frame
                  CrossDn[i] = iCustom(NULL,timeFrame,indicatorFileName,"",maPeriod1,Ma1Type,maPeriod2,Ma1Type,MaPrice,arrowSize,3,y);  // to get the results of regular calculation
            }
         }
    return(0); // finish the multi time frame processing
    }
         
   //
   //
   // regular calculation - indicator will go here if timeFrame==Period() - when called from iCustom() call
   //
   //         
   
   for (i=limit; i>=0; i--) ma1[i] = iMA(NULL,0,maPeriod1,0,Ma1Type,MaPrice,i);
   for (i=limit; i>=0; i--) 
   {
      ma2[i] = iMAOnArray(ma1,0,maPeriod2,0,Ma2Type,i);
      trend[i] = trend[i+1];
         if (ma1[i]>ma2[i]) trend[i] = 1;
         if (ma1[i]<ma2[i]) trend[i] =-1;
         
         //
         //
         //
         //
         //
      
         CrossUp[i] = EMPTY_VALUE;
         CrossDn[i] = EMPTY_VALUE;
         if (trend[i]!= trend[i+1])
         if (trend[i] == 1)
               CrossUp[i] = ma2[i] - iATR(NULL,0,20,i)/2;
         else  CrossDn[i] = ma2[i] + iATR(NULL,0,20,i)/2;
     }
   return(0);
}

//-------------------------------------------------------------------
//
//-------------------------------------------------------------------
//
//
//
//
//

string sTfTable[] = {"M1","M5","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,15,30,60,240,1440,10080,43200};

//
//
//
//
//

int stringToTimeFrame(string tfs)
{
   tfs = stringUpperCase(tfs);
   for (int i=ArraySize(iTfTable)-1; i>=0; i--)
         if (tfs==sTfTable[i] || tfs==""+iTfTable[i]) return(MathMax(iTfTable[i],Period()));
                                                      return(Period());
}

//
//
//
//
//

string stringUpperCase(string str)
{
   string   s = str;

   for (int length=StringLen(str)-1; length>=0; length--)
   {
      int char = StringGetChar(s, length);
         if((char > 96 && char < 123) || (char > 223 && char < 256))
                     s = StringSetChar(s, length, char - 32);
         else if(char > -33 && char < 0)
                     s = StringSetChar(s, length, char + 224);
   }
   return(s);
}